import type { Route, Params } from './router';
import type { CacheFs } from '../shared/lib/utils';
import type { NextParsedUrlQuery } from './request-meta';
import type { FontManifest } from './font-utils';
import { PagesManifest } from '../build/webpack/plugins/pages-manifest-plugin';
import BaseServer, { FindComponentsResult } from './base-server';
export * from './base-server';
export default class NextNodeServer extends BaseServer {
    protected getHasStaticDir(): boolean;
    protected getPagesManifest(): PagesManifest | undefined;
    protected getBuildId(): string;
    protected generateImageRoutes(): Route[];
    protected generatePublicRoutes(): Route[];
    private _validFilesystemPathSet;
    protected getFilesystemPaths(): Set<string>;
    protected getPagePath(pathname: string, locales?: string[]): string;
    protected findPageComponents(pathname: string, query?: NextParsedUrlQuery, params?: Params | null): Promise<FindComponentsResult | null>;
    protected getFontManifest(): FontManifest;
    protected getCacheFilesystem(): CacheFs;
    protected getMiddlewareInfo(params: {
        dev?: boolean;
        distDir: string;
        page: string;
        serverless: boolean;
    }): {
        name: string;
        paths: string[];
        env: string[];
    };
}
